"use strict";

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var SonicBoom = require('sonic-boom');

var noop = function noop() {};

var Sonic = /*#__PURE__*/function () {
  function Sonic(stream) {
    var _this = this;

    var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, Sonic);

    var _opts$minLength = opts.minLength,
        minLength = _opts$minLength === void 0 ? 4096 : _opts$minLength,
        _opts$timeout = opts.timeout,
        timeout = _opts$timeout === void 0 ? 1000 : _opts$timeout;
    this._timer = undefined;
    this._timeout = timeout;

    var _ref = typeof stream === 'string' ? {
      path: stream
    } : stream,
        fd = _ref.fd,
        path = _ref.path;

    this.stream = new SonicBoom({
      fd: fd,
      dest: path,
      minLength: minLength,
      sync: true
    });
    this.stream.on('error', filterBrokenPipe.bind(null, this.stream));
    process.on('exit', function () {
      _this.flush();
    });
  }

  _createClass(Sonic, [{
    key: "write",
    value: function write(data) {
      var _this2 = this;

      this.stream.write(data);

      if (!this._timer) {
        this._timer = setTimeout(function () {
          _this2.flush();

          _this2._timer = undefined;
        }, this._timeout);
      }

      return true;
    }
  }, {
    key: "flush",
    value: function flush() {
      if (!this.stream.destroyed) {
        this.stream.flushSync();
      }
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.stream.destroy();
    }
  }]);

  return Sonic;
}();

function filterBrokenPipe(stream, err) {
  if (err.code === 'EPIPE') {
    // If we get EPIPE, we should stop logging here
    // however we have no control to the consumer of
    // SonicBoom, so we just overwrite the write method
    stream.write = noop;
    stream.end = noop;
    stream.flushSync = noop;
    stream.destroy = noop;
    return;
  }

  stream.removeListener('error', filterBrokenPipe);
}

module.exports = Sonic;