"use strict";

function _toArray(arr) { return _arrayWithHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var debug = require('debug');

var wrapped = null;

var unwrap = function unwrap() {
  if (wrapped) {
    Object.keys(wrapped).forEach(function (key) {
      debug[key] = wrapped[key];
    });
    wrapped = null;
  }
};

function wrapDebug(Log) {
  if (wrapped) return unwrap;

  var Loggers = /*#__PURE__*/function () {
    function Loggers() {
      _classCallCheck(this, Loggers);

      this.cache = {};
    }

    _createClass(Loggers, [{
      key: "get",
      value: function get(namespace) {
        var logger = this.cache[namespace];

        if (!logger) {
          logger = this.cache[namespace] = new Log(namespace);
        }

        return logger;
      }
    }]);

    return Loggers;
  }();

  var loggers = new Loggers();
  wrapped = {
    log: debug.log,
    useColors: debug.useColors
  };

  debug.useColors = function () {
    return false;
  };

  debug.log = function (fmt) {
    // eslint-disable-next-line no-unused-vars
    var _fmt$split = fmt.split(' '),
        _fmt$split2 = _toArray(_fmt$split),
        time = _fmt$split2[0],
        namespace = _fmt$split2[1],
        rest = _fmt$split2.slice(2);

    var _fmt = rest.join(' '); // console.log(time, namespace, rest, args)


    var log = loggers.get(namespace);

    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    log.debug.apply(log, [_fmt].concat(args));
  };

  return unwrap;
}

module.exports = wrapDebug;